#include <stdio.h>
#include "data.h"


main(argc, argv)
int argc;
char **argv;
{
  char* executable;
  int machine_type;
  int machine_list[4];
  int type;
  int loopcnt;
  void *task_id = &task_id;
  void *L_inverse_task_id = &L_inverse_task_id;
  void *U_inverse_task_id = &U_inverse_task_id;
  void *done_task_id; 
  

  VCE_init(argc, argv);
  machine_list[0] = ATM;
  machine_list[1] = SP2;
  machine_list[2] = 0;
  
  VCE_copy_inputfile("A", machine_list, 0);
  VCE_copy_inputfile("B", machine_list, 0);

  VCE_launch(SP2, "VCE/SP2/LU/LU","A L U", 2, task_id);
  VCE_launch(ATM, "VCE/ATM/LU/LU","A L U", 2, task_id);
  type = VCE_wait_for_status(&machine_type, &task_id); 
  printf("machine %d task_id %d\n", machine_type, task_id);

  if (machine_type == SP2)
    {
     p4_dprintf("SP2 won for decomposition\n");
     
     VCE_kill_executable(ATM, task_id);

     VCE_cleanup("L", machine_list, SP2);

     VCE_cleanup("U", machine_list, SP2);

     VCE_copy_inputfile("L", machine_list, SP2);

     VCE_copy_inputfile("U", machine_list, SP2);
    } 

  else
    {
     p4_dprintf("ATM won for decomposition\n");

     VCE_kill_executable(SP2, task_id);

     VCE_cleanup("L", machine_list, ATM);

     VCE_cleanup("U", machine_list, ATM);

     VCE_copy_inputfile("L", machine_list, ATM);

     VCE_copy_inputfile("U", machine_list, ATM);
    }

  p4_dprintf("Decomposition complete\n"); 



  VCE_launch(SP2, "VCE/SP2/Inverse/Inverse","L L-1", 2, L_inverse_task_id); 
  VCE_launch(ATM, "VCE/ATM/Inverse/Inverse","L L-1", 2, L_inverse_task_id); 
  VCE_launch(SP2, "VCE/SP2/Inverse/Inverse","U U-1", 2, U_inverse_task_id); 
  VCE_launch(ATM, "VCE/ATM/Inverse/Inverse","U U-1", 2, U_inverse_task_id); 


  for (loopcnt = 0; loopcnt < 2; loopcnt++)
     { 
       type = VCE_wait_for_status(&machine_type, &done_task_id); 
       printf("machine %d task_id %d\n", machine_type, done_task_id);

        if (machine_type == SP2)
          {
           p4_dprintf("SP2 won for an inversion\n");
     
           VCE_kill_executable(ATM, done_task_id);

           if (done_task_id == L_inverse_task_id)
             {
              VCE_cleanup("L-1", machine_list, SP2);

              VCE_copy_inputfile("L-1", machine_list, SP2);
	     }

           else
             {
              VCE_cleanup("U-1", machine_list, SP2);

              VCE_copy_inputfile("U-1", machine_list, SP2);
	     } 
          } 

        else
          { 
           p4_dprintf("ATM won for an inversion\n");

           VCE_kill_executable(ATM, task_id);

           if (done_task_id == L_inverse_task_id)
             {
              VCE_cleanup("L-1", machine_list, ATM);

              VCE_copy_inputfile("L-1", machine_list, ATM);
	     }

           else
             {
              VCE_cleanup("U-1", machine_list, ATM);

              VCE_copy_inputfile("U-1", machine_list, ATM);
	     } 
          }
     } 

  p4_dprintf("Inverses complete\n"); 

  VCE_launch(SP2, "VCE/SP2/X/X","L-1 B TEMP", 2, task_id);
  VCE_launch(ATM, "VCE/ATM/X/X","L-1 B TEMP", 2, task_id);
  type = VCE_wait_for_status(&machine_type, &task_id); 
  printf("machine %d task_id %d\n", machine_type, task_id);

  if (machine_type == SP2)
    {
     p4_dprintf("SP2 won for first multipliacation\n");
     
     VCE_kill_executable(ATM, task_id);

     VCE_cleanup("TEMP", machine_list, SP2);

     VCE_copy_inputfile("TEMP", machine_list, SP2);
    } 

  else
    {
     p4_dprintf("ATM won for first multipliacation\n");
     
     VCE_kill_executable(SP2, task_id);

     VCE_cleanup("TEMP", machine_list, ATM);

     VCE_copy_inputfile("TEMP", machine_list, ATM);

    }

  p4_dprintf("First multiplication complete\n"); 

  VCE_launch(SP2, "VCE/SP2/X/X","U-1 TEMP X1", 2, task_id);
  VCE_launch(ATM, "VCE/ATM/X/X","U-1 TEMP X1", 2, task_id);
  type = VCE_wait_for_status(&machine_type, &task_id); 
  printf("machine %d task_id %d\n", machine_type, task_id);

  if (machine_type == SP2)
    {
     p4_dprintf("SP2 won for second multipliacation\n");
     
     VCE_kill_executable(ATM, task_id);

     VCE_cleanup("X1", machine_list, SP2);
    } 

  else
    {
     p4_dprintf("ATM won for second multipliacation\n");
     
     VCE_kill_executable(SP2, task_id);

     VCE_cleanup("X1", machine_list, ATM);

    }

  p4_dprintf("Second multiplication complete\n"); 

  VCE_shutdown();
} 




